﻿'
' webCam form 1
Option Explicit On
Public Class Form1


  Enum PlayState
    Stopped
    Paused
    Running
    Init
  End Enum


  Dim CurrentState As PlayState = PlayState.Stopped
  Dim D As Integer = Convert.ToInt32("0X8000", 16)
  Public WM_GRAPHNOTIFY As Integer = D + 1
  Dim VideoWindow As DirectShowLib.IVideoWindow = Nothing
  Dim MediaControl As DirectShowLib.IMediaControl = Nothing
  Dim MediaEventEx As DirectShowLib.IMediaEventEx = Nothing
  Dim GraphBuilder As DirectShowLib.IGraphBuilder = Nothing
  Dim CaptureGraphBuilder As DirectShowLib.ICaptureGraphBuilder2 = Nothing
  Dim rot As DirectShowLib.DsROTEntry = Nothing
  Dim x As Integer = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width
  Dim y As Integer = System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height
  Dim calcul_X As Double = x / y
  Dim calcul_Y As Double = y / x
  Private dernierpoint As Point


  Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
    Dim hr As Integer = 0
    Dim sourceFilter As DirectShowLib.IBaseFilter = Nothing
    Left = 100
    Top = Left
    '
    PictureBox2.Visible = False
    Call AuPremierPlanToolStripMenuItem_Click(sender, e)
    AuPremierPlanToolStripMenuItem.Checked = True
    ALarrièrePlanToolStripMenuItem.Checked = False
    '
    Try
      GetInterfaces()
      hr = CaptureGraphBuilder.SetFiltergraph(GraphBuilder) 'Specifies filter graph "graphbuilder" for the capture graph builder "captureGraphBuilder" to use.
      Debug.WriteLine("Attach the filter graph to the capture graph : " & DirectShowLib.DsError.GetErrorText(hr))
      DirectShowLib.DsError.ThrowExceptionForHR(hr)
      SourceFilter = FindCaptureDevice()
      hr = GraphBuilder.AddFilter(SourceFilter, "Video Capture")
      Debug.WriteLine("Add capture filter to our graph : " & DirectShowLib.DsError.GetErrorText(hr))
      DirectShowLib.DsError.ThrowExceptionForHR(hr)
      hr = CaptureGraphBuilder.RenderStream(DirectShowLib.PinCategory.Preview, DirectShowLib.MediaType.Video, SourceFilter, Nothing, Nothing)
      Debug.WriteLine("Render the preview pin on the video capture filter : " & DirectShowLib.DsError.GetErrorText(hr))
      DirectShowLib.DsError.ThrowExceptionForHR(hr)
      Runtime.InteropServices.Marshal.ReleaseComObject(SourceFilter)
      SetupVideoWindow()
      rot = New DirectShowLib.DsROTEntry(GraphBuilder)
      hr = MediaControl.Run()
      Debug.WriteLine("Start previewing video data : " & DirectShowLib.DsError.GetErrorText(hr))
      DirectShowLib.DsError.ThrowExceptionForHR(hr)
      CurrentState = PlayState.Running
      Debug.WriteLine("The currentstate : " & CurrentState.ToString)
    Catch ex As Exception
      MessageBox.Show("An unrecoverable error has occurred.With error : " & ex.ToString)
    End Try
  End Sub


  Sub Form1_Shown(sender As Object, e As EventArgs) Handles Me.Shown
    Width = 400
    Call SetClientFormSize(Width, Width * calcul_Y)
  End Sub


  Sub SetClientFormSize(ByVal NewWidth As Integer, ByVal NewHeight As Integer) ' dimensions internes ' Jacques
    Dim BorderWidth As Integer
    Dim TitleHeight As Integer
    BorderWidth = (Me.Width - Me.ClientSize.Width) / 2
    TitleHeight = Me.Height - (Me.ClientSize.Height + (BorderWidth * 2))
    Me.Width = NewWidth + (BorderWidth * 2)
    Me.Height = NewHeight + TitleHeight + (BorderWidth * 2)
  End Sub


  Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
    Call ResizeVideoWindow()
  End Sub


  Sub ResizeVideoWindow() ' fonction d'origine
    PictureBox1.Width = Width - 20
    PictureBox1.Height = ClientSize.Height - 65
    If VideoWindow IsNot Nothing Then VideoWindow.SetWindowPosition(0, 0, PictureBox1.Width, PictureBox1.Height)
  End Sub


  Sub xCaptureVideo()
    Dim hr As Integer = 0
    Dim sourceFilter As DirectShowLib.IBaseFilter = Nothing
    Try
      GetInterfaces()
      hr = CaptureGraphBuilder.SetFiltergraph(GraphBuilder) 'Specifies filter graph "graphbuilder" for the capture graph builder "captureGraphBuilder" to use.
      Debug.WriteLine("Attach the filter graph to the capture graph : " & DirectShowLib.DsError.GetErrorText(hr))
      DirectShowLib.DsError.ThrowExceptionForHR(hr)
      sourceFilter = FindCaptureDevice()
      hr = GraphBuilder.AddFilter(sourceFilter, "Video Capture")
      Debug.WriteLine("Add capture filter to our graph : " & DirectShowLib.DsError.GetErrorText(hr))
      DirectShowLib.DsError.ThrowExceptionForHR(hr)
      hr = CaptureGraphBuilder.RenderStream(DirectShowLib.PinCategory.Preview, DirectShowLib.MediaType.Video, sourceFilter, Nothing, Nothing)
      Debug.WriteLine("Render the preview pin on the video capture filter : " & DirectShowLib.DsError.GetErrorText(hr))
      DirectShowLib.DsError.ThrowExceptionForHR(hr)
      Runtime.InteropServices.Marshal.ReleaseComObject(sourceFilter)
      SetupVideoWindow()
      rot = New DirectShowLib.DsROTEntry(GraphBuilder)
      hr = MediaControl.Run()
      Debug.WriteLine("Start previewing video data : " & DirectShowLib.DsError.GetErrorText(hr))
      DirectShowLib.DsError.ThrowExceptionForHR(hr)
      CurrentState = PlayState.Running
      Debug.WriteLine("The currentstate : " & CurrentState.ToString)
    Catch ex As Exception
      MessageBox.Show("An unrecoverable error has occurred.With error : " & ex.ToString)
    End Try
  End Sub


  Sub GetInterfaces()
    Dim hr As Integer = 0
    GraphBuilder = CType(New DirectShowLib.FilterGraph, DirectShowLib.IGraphBuilder)
    CaptureGraphBuilder = CType(New DirectShowLib.CaptureGraphBuilder2, DirectShowLib.ICaptureGraphBuilder2)
    MediaControl = CType(GraphBuilder, DirectShowLib.IMediaControl)
    VideoWindow = CType(GraphBuilder, DirectShowLib.IVideoWindow)
    MediaEventEx = CType(GraphBuilder, DirectShowLib.IMediaEventEx)
    hr = MediaEventEx.SetNotifyWindow(PictureBox1.Handle, WM_GRAPHNOTIFY, IntPtr.Zero) 'This method designates a window as the recipient of messages generated by or sent to the current DirectShow object
    DirectShowLib.DsError.ThrowExceptionForHR(hr) 'ThrowExceptionForHR is a wrapper for Marshal.ThrowExceptionForHR, but additionally provides descriptions for any DirectShow specific error messages.If the hr value is not a fatal error, no exception will be thrown:
    Debug.WriteLine("I started Sub Get interfaces , the result is : " & DirectShowLib.DsError.GetErrorText(hr))
  End Sub


  Function FindCaptureDevice() As DirectShowLib.IBaseFilter
    Debug.WriteLine("Start the Sub FindCaptureDevice")
    Dim hr As Integer = 0
    Dim classEnum As Runtime.InteropServices.ComTypes.IEnumMoniker = Nothing
    Dim moniker As Runtime.InteropServices.ComTypes.IMoniker() = New Runtime.InteropServices.ComTypes.IMoniker(0) {}
    Dim source As Object = Nothing
    Dim devEnum As DirectShowLib.ICreateDevEnum = CType(New DirectShowLib.CreateDevEnum, DirectShowLib.ICreateDevEnum)
    hr = devEnum.CreateClassEnumerator(DirectShowLib.FilterCategory.VideoInputDevice, classEnum, 0)
    Debug.WriteLine("Create an enumerator for the video capture devices : " & DirectShowLib.DsError.GetErrorText(hr))
    DirectShowLib.DsError.ThrowExceptionForHR(hr)
    Runtime.InteropServices.Marshal.ReleaseComObject(devEnum)
    If classEnum Is Nothing Then
      Throw New ApplicationException("No video capture device was detected.\r\n\r\n" & "This sample requires a video capture device, such as a USB WebCam,\r\n" & _
          "to be installed and working properly.  The sample will now close.")
    End If
    If classEnum.Next(moniker.Length, moniker, IntPtr.Zero) = 0 Then
      Dim iid As Guid = GetType(DirectShowLib.IBaseFilter).GUID
      moniker(0).BindToObject(Nothing, Nothing, iid, source)
    Else
      Throw New ApplicationException("Unable to access video capture device!")
    End If
    Runtime.InteropServices.Marshal.ReleaseComObject(moniker(0))
    Runtime.InteropServices.Marshal.ReleaseComObject(classEnum)
    Return CType(source, DirectShowLib.IBaseFilter)
  End Function


  Sub SetupVideoWindow()
    Dim hr As Integer = 0
    hr = VideoWindow.put_Owner(PictureBox1.Handle)
    DirectShowLib.DsError.ThrowExceptionForHR(hr)
    hr = VideoWindow.put_WindowStyle(DirectShowLib.WindowStyle.Child Or DirectShowLib.WindowStyle.ClipChildren)
    DirectShowLib.DsError.ThrowExceptionForHR(hr)
    ResizeVideoWindow()
    hr = VideoWindow.put_Visible(DirectShowLib.OABool.True)
    DirectShowLib.DsError.ThrowExceptionForHR(hr)
  End Sub


  Protected Overloads Sub WndProc(ByRef m As Message)
    Select Case m.Msg
      Case WM_GRAPHNOTIFY
        HandleGraphEvent()
    End Select
    If Not (VideoWindow Is Nothing) Then VideoWindow.NotifyOwnerMessage(m.HWnd, m.Msg, m.WParam.ToInt32, m.LParam.ToInt32)
    MyBase.WndProc(m)
  End Sub


  Sub HandleGraphEvent()
    Dim hr As Integer = 0
    Dim evCode As DirectShowLib.EventCode
    Dim evParam1 As Integer
    Dim evParam2 As Integer
    If MediaEventEx Is Nothing Then Return
    While MediaEventEx.GetEvent(evCode, evParam1, evParam2, 0) = 0
      hr = MediaEventEx.FreeEventParams(evCode, evParam1, evParam2)
      DirectShowLib.DsError.ThrowExceptionForHR(hr)
    End While
  End Sub


  Sub GrabImage()
    Try
      PictureBox2.Visible = True
      MediaControl.Pause()
      Dim bmp As New Bitmap(PictureBox1.Width, PictureBox1.Height)
      Using g As Graphics = Graphics.FromImage(bmp)
        Dim pt As Point = PictureBox1.PointToScreen(New Point(0, 0))
        g.CopyFromScreen(pt.X, pt.Y, 0, 0, bmp.Size)
      End Using
      PictureBox2.Image = bmp
      MediaControl.Run()
      PictureBox2.Visible = False
    Catch
    End Try
  End Sub


  Sub PhotographierToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles PhotographierToolStripMenuItem.Click
    Dim sfdImage As New SaveFileDialog ' photographier
    GrabImage()
    sfdImage.DefaultExt = "bmp"
    sfdImage.Filter = "Fichiers image (*.bmp)|*.bmp | All files (*.*)|*.*"
    sfdImage.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.MyPictures)
    If sfdImage.ShowDialog = DialogResult.OK Then PictureBox2.Image.Save(sfdImage.FileName, Imaging.ImageFormat.Bmp)
  End Sub


  Sub AuPremierPlanToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles AuPremierPlanToolStripMenuItem.Click
    TopMost = True ' 1er plan
    AuPremierPlanToolStripMenuItem.Checked = True
    ALarrièrePlanToolStripMenuItem.Checked = False
  End Sub


  Sub ALarrièrePlanToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles ALarrièrePlanToolStripMenuItem.Click
    TopMost = False ' arrière plan
    AuPremierPlanToolStripMenuItem.Checked = False
    ALarrièrePlanToolStripMenuItem.Checked = True
  End Sub


  Sub Form1_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
    On Error Resume Next
    MediaControl.StopWhenReady()
    CurrentState = PlayState.Stopped
    MediaEventEx.SetNotifyWindow(IntPtr.Zero, WM_GRAPHNOTIFY, IntPtr.Zero)
    VideoWindow.put_Visible(DirectShowLib.OABool.False)
    VideoWindow.put_Owner(IntPtr.Zero)
    rot.Dispose()
    rot = Nothing
    Runtime.InteropServices.Marshal.ReleaseComObject(MediaControl) : MediaControl = Nothing
    Runtime.InteropServices.Marshal.ReleaseComObject(MediaEventEx) : MediaEventEx = Nothing
    Runtime.InteropServices.Marshal.ReleaseComObject(VideoWindow) : VideoWindow = Nothing
    Runtime.InteropServices.Marshal.ReleaseComObject(GraphBuilder) : GraphBuilder = Nothing
    Runtime.InteropServices.Marshal.ReleaseComObject(CaptureGraphBuilder) : CaptureGraphBuilder = Nothing
  End Sub


End Class
